-- bounding box collision
function bb(ax1,ay1,aw,ah, bx1,by1,bw,bh)
  local ax2,ay2,bx2,by2 = ax1 + aw, ay1 + ah, bx1 + bw, by1 + bh
  return ax1 < bx2 and ax2 > bx1 and ay1 < by2 and ay2 > by1
end

-- circle collision
function cc(x1,y1,x2,y2)
	return math.sqrt((x2-x1)^2+(y2-y1)^2)
end

function check(table, dt)
  for i,v in ipairs(table) do
    for j = i + 1, #table do
      if j ~= nil then
				if table[i].dead == false and table[j].dead == false then
		      if bb(table[i].x, table[i].y, table[i].w, table[i].h, table[j].x, table[j].y, table[j].w, table[j].h) then
						if table[i].state == "standing" then
							if table[j].state == "fastfalling" then
								table[i].dead = true 
							end
						end
						table[i].y = table[i].oldy
						table[j].y = table[j].oldy

						table[j].state = "standing"
						if table[i].x > table[j].x then table[i].x = table[i].x - (table[i].speed * dt) end
					 if table[i].x < table[j].x then table[i].x = table[i].x + (table[i].speed * dt) end
		      end
				end
      end
    end
  end
end
