
local helicopter = {}
helicopter.__index = helicopter

local function new()
  return setmetatable({}, helicopter)
end

function helicopter:init(x,y,laneNumber,laneDirection)
  -- Base Attributes
	self.x = x
	self.y = y
	self.lane = laneNumber
	self.direction = laneDirection
	
	self.dead = false
	self.dropRate = math.random(20,100)/10
	-- Specific Attributes
	self.w = 64
	self.h = 32
	self.speed = 100
	self.health = 100
	self.points = 20
	self.birthTime = love.timer.getTime()
	self.age = 0
	self.dropCount = 0
	table.insert(activeEnt, self)
	table.insert(lane[laneNumber], laneDirection)

end

function helicopter:drop()
	if self.age - (self.dropCount * 3) > self.dropRate then
		if self.x > 0 and self.x < (1024-self.w) then
			enemyNum = enemyNum + 1
			enemy[enemyNum] = paratrooper()
			enemy[enemyNum]:init(self.x, self.y)
			self.dropCount = self.dropCount + 1
		end
	end
end

function helicopter:update(dt)
	self.age = love.timer.getTime() - self.birthTime
	self:drop()
	-- Handles what direction the helicopter flies
	if self.direction == 'right' then 
		self.x = self.x + (self.speed*dt)
	elseif self.direction == 'left' then
		self.x = self.x - (self.speed*dt)
	end
	-- Kill entity if it goes off the screen
	if self.x < -65 or self.x > 1066 then self:kill("quiet") end

end

function helicopter:draw()

	love.graphics.setColor(255,0,0,255)
	love.graphics.rectangle("line", self.x, self.y, self.w, self.h)
	love.graphics.setColor(255,255,255,255)

end

function helicopter:kill(how)
	if how == "quiet" then
		
	end
	self.dead = true
	table.remove(lane[self.lane], 1)
end

return setmetatable({new = new},
  {__call = function(_, ...) return new(...) end})
