
local paratrooper = {}
paratrooper.__index = paratrooper

local function new()
  return setmetatable({}, paratrooper)
end

function paratrooper:init(x,y)
  -- Base Attributes
	self.x = x
	self.y = y
	
	self.dead = false

	-- Specific Attributes
	self.w = 16
	self.h = 32
	self.speed = 40
	self.points = 20
	self.state = "falling"
	self.chuteX = self.x + (self.w/2)
	self.chuteY = self.y - 15

	table.insert(activeEnt, self)
	table.insert(paratroopers, self)
	table.insert(lane[laneNumber], laneDirection)

end

function paratrooper:update(dt)

	self.oldx = self.x
	self.oldy = self.y

	if self.state == "falling" or self.state == "fastfalling" then
		self.y = self.y + (self.speed*dt)
	end	

	if self.state == "standing" then 
		if self.y < (640-self.h) then
			self.y = self.y + (self.speed*dt)
		end
	end

	if self.y > (640-self.h-1) then
		if self.speed > 100 then 
			self.dead = true 
		else
			self.state = "standing"
			self.y = (640-self.h) 
		end
	end

	self.chuteX = self.x + (self.w/2)
	self.chuteY = self.y - 15

end

function paratrooper:draw()

	love.graphics.setColor(0,0,255,255)
	love.graphics.rectangle("line", self.x, self.y, self.w, self.h)
	if self.state == "falling" then 
		love.graphics.circle("line", self.chuteX, self.chuteY, 20)
	end
	love.graphics.setColor(255,255,255,255)

end

function paratrooper:kill(how)
	if how == "quiet" then
		
	end
	self.dead = true
	table.remove(lane[self.lane], 1)
end

return setmetatable({new = new},
  {__call = function(_, ...) return new(...) end})
