
local player = {}
player.__index = player

local function new()
  return setmetatable({}, player)
end

function player:init(x, y, w, h)

  self.w = w
	self.h = h
	self.x = x
	self.y = y
	self.health = 100
	self.dead = false
	self.entityType = "player"
	self.level = 1
	table.insert(activeEnt, self)
	self.bfired = 0
	self.score = 10
	self.bullets = {}
	self.barrelImg = love.graphics.newImage("assets/barrel.png")
end

function player:update(dt)

	self.angle = math.atan2((love.mouse.getY() - self.y),(love.mouse.getX() - (self.x + (self.w/2))))

	if getAmount() > 10 then self.dead = true end

	if self.dead == true then gameState = "gameover" end

end

function player:draw()

	love.graphics.setColor(0,255,0,255)
	love.graphics.rectangle("line", self.x, self.y, self.w, self.h)
	love.graphics.print(self.angle, 100, 100)
	love.graphics.setColor(255,255,255,255)
	love.graphics.draw(self.barrelImg, self.x + (self.w/2), self.y, self.angle-4.7, 1, 1, 5,40)

end

function player:mousepressed(x,y,button)
	if button == "l" then
		self.bfired = self.bfired + 1
		self.bullets[self.bfired] = bullet()
		self.bullets[self.bfired]:init( 500, self.x+(self.w/2),self.y, love.mouse.getX(), love.mouse.getY(), 3)
		if self.score > 0 then self.score = self.score - 5 end
	end
end

function player:mousereleased(x,y,button)

end

return setmetatable({new = new},
  {__call = function(_, ...) return new(...) end})
