
local bullet = {}
bullet.__index = bullet

local function new()
  return setmetatable({}, bullet)
end

function bullet:init(speed, x, y, mx, my, w)

  self.w = w
	self.x = x
	self.y = y
	self.speed = speed
	self.mx = mx	-- mouse x
	self.my = my	-- mouse y
	self.angle = math.atan2((self.my - self.y),(self.mx - self.x)) -- angle of start - start,mouse - mouse
	self.dx = self.speed * math.cos(self.angle) -- this handels direction x
	self.dy = self.speed * math.sin(self.angle) -- this handels direction y
	self.dead = false
	self.entityType = "bullet"
	table.insert(activeEnt, self)

end

function bullet:update(dt)

	-- Collision
	if enemy[1] ~= nil then
		for i,v in ipairs(enemy) do
			if enemy[i].dead == false and self.dead == false then
				if bb(self.x, self.y, 3, 3, enemy[i].x, enemy[i].y, enemy[i].w, enemy[i].h) then 
					self.dead = true
					enemy[i].dead = true
					player1.score = player1.score + enemy[i].points
				end
				if enemy[i].chuteX ~= nil and enemy[i].state == "falling" then
					if cc(self.x, self.y, enemy[i].chuteX, enemy[i].chuteY) < 20 then 
						enemy[i].speed = 150 	
						enemy[i].state = "fastfalling"
						self.dead = true				
					end
				end
			end
		end
	end


	self.x = self.x + (self.dx * dt)
	self.y = self.y + (self.dy * dt)

	if self.x < -10 or self.y < -10 or self.x > 1200 or self.y > 700 then self.dead = true end

end

function bullet:draw()

	love.graphics.setColor(0,0,255)
	love.graphics.circle("line", self.x, self.y, self.w)
	love.graphics.setColor(255,255,255,255)
end

function bullet:mousepressed(x,y,button)

end

function bullet:mousereleased(x,y,button)

end

return setmetatable({new = new},
  {__call = function(_, ...) return new(...) end})
